OneLineTest = function () {
    var test = new Test();
    var check_time = 300;
    var remove_modal_time = 350;

    //////Common Functions
    OneLineTest.prototype.SelectProtocolName = function (protocol_name) {
        var value = 0;
        switch (protocol_name) {
            case "":
                value = 1;
                break;
            case "ICMP":
                value = 2;
                break;
            case "TCP":
                value = 3;
                break;
            case "UDP":
                value = 4;
                break;
        }
        $("#one-protocol").val(value);
    }
    OneLineTest.prototype.InputForm = function (srcfw, srcip, srcport, dstfw, dstip, dstport, nat_dstip, nat_dstport) {
        $("#one-srcfw").val(srcfw);
        $("#one-srcip").val(srcip);
        $("#one-srcport").val(srcport);
        $("#one-dstfw").val(dstfw);
        $("#one-dstip").val(dstip);
        $("#one-dstport").val(dstport);
        $("#one-nat-dstip").val(nat_dstip);
        $("#one-nat-dstport").val(nat_dstport);
    }
    OneLineTest.prototype.ExitError = function (error_name) {
        var errormsg = $("#modal-oneline-param-invalid-errors").text();
        console.log("errormsg: \n", errormsg)
        var result = errormsg.indexOf(error_name);
        if (result === -1) {//エラー文が存在しない
            return 0;
        } else {
            return 1;
        }
    }
    OneLineTest.prototype.NormalCheck = function (error_name, test_number) {
        console.info("Check: " + error_name);
        var result = this.ExitError(error_name);
        if (result === 1) {//エラーがあったら失敗
            TestResult("NG", test_number);
        } else { TestResult("OK", test_number); }
    }
    OneLineTest.prototype.AbnormalCheck = function (error_name, test_number) {
        console.info("Check: " + error_name)
        var result = this.ExitError(error_name);
        if (result === 0) {//エラーがなかったら失敗
            TestResult("NG", test_number);
        } else { TestResult("OK", test_number); }
    }
    OneLineTest.prototype.RemoveModal = function () {
        setTimeout(function () {
            if (counter !== -1) {
                $('#modal-oneline-param-invalid').css('display', 'none'); ++count;
            } else {
                count = 0;
            }
        }, remove_modal_time);
    }

    //////Functions
    OneLineTest.prototype.ICMPNormal = function (n) {
        this.SelectProtocolName("ICMP");
        var that = this;
        var ips = ["192.168.81.254","192.168.100.2/24","","200.200.200.1","203.0.113.143/24","","200.200.200.100",""]
        switch (n) {
            case 0:
                $("#one-run").click();
                setTimeout(this.NormalCheck("Protocol name is invalid", "2"), check_time);
                break;
            case 1:
                this.InputForm(ips[0], "", "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Src-side FW is invalid", "3"); }, check_time);
                break;
            case 2:
                this.InputForm(ips[0], ips[1], "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Source IP address is invalid", "4"); }, check_time);
                setTimeout(function () { that.NormalCheck("In the case of ICMP, source port number can not be specified", "5"); }, check_time);
                break;
            case 3:
                this.InputForm(ips[0], ips[1], "", ips[3], "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Dst-side FW is invalid", "6"); }, check_time);
                break;
            case 4:
                this.InputForm(ips[0], ips[1], "", ips[3], ips[4], "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Destination IP address is invalid", "7"); }, check_time);
                setTimeout(function () { that.NormalCheck("In the case of ICMP,destination port number can not be specified", "8"); }, check_time);
                setTimeout(function () { that.NormalCheck("Destination-NAT IP address is invalid", "9"); }, check_time);
                break;
            case 5:
                this.InputForm(ips[0], ips[1], "", ips[3], ips[4], "", ips[6], "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Destination-NAT IP address is invalid", "10"); }, check_time);
                setTimeout(function () { that.NormalCheck("Destination-NAT port number is invalid", "11"); }, check_time);
                break;
            default:
                console.info("Test End");
                count = -1;
                break;
        }
    }

    OneLineTest.prototype.TCPNormal = function (n) {
        var that = this;
        var ips = ["192.168.81.254","192.168.100.2/24","12345","200.200.200.1","203.0.113.143/24","80","200.200.200.100","80"];
        switch (n) {
            case 0:
                this.SelectProtocolName("TCP");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Protocol name is invalid", "12"); }, check_time)
                break;
            case 1:
                this.InputForm(ips[0], "", "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Src-side FW is invalid", "13"); }, check_time);
                break;
            case 2:
                this.InputForm(ips[0], ips[1], "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Source IP address is invalid", "14"); }, check_time);
                setTimeout(function () { that.NormalCheck("Source Port Number is invalid", "15"); }, check_time);
                break;
            case 3:
                this.InputForm(ips[0], ips[1], ips[2], "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Source Port Number is invalid", "16"); }, check_time);
                break;
            case 4:
                this.InputForm(ips[0], ips[1], ips[2], ips[3], "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Dst-side FW is invalid", "17"); }, check_time);
                break;
            case 5:
                this.InputForm(ips[0], ips[1], ips[2], ips[3], ips[4], "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Destination IP address is invalid", "18"); }, check_time);
                break;
            case 6:
                this.InputForm(ips[0], ips[1], ips[2], ips[3], ips[4], ips[5], "", "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Destination Port number is invalid", "19"); }, check_time);
                setTimeout(function () { that.NormalCheck("Destination-NAT IP address is invalid", "20"); }, check_time);
                break;
            case 7:
                this.InputForm(ips[0], ips[1], "", ips[3], ips[4], "", ips[6], "");
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Destination-NAT IP address is invalid", "21"); }, check_time);
                setTimeout(function () { that.NormalCheck("Destination-NAT port number is invalid", "22"); }, check_time);
                break;
            case 8:
                this.InputForm(ips[0], ips[1], "", ips[3], ips[4], "", ips[6], ips[7]);
                $("#one-run").click();
                setTimeout(function () { that.NormalCheck("Destination-NAT port number is invalid", "23"); }, check_time);
                break;
            default:
                console.info("Test End");
                count = -1;
                break;
        }
    }
    OneLineTest.prototype.UDPNormal = function (n) {
        if (n === 0) {//protocolをUDPに変えて、あとはTCPと同一の試験
            this.SelectProtocolName("UDP");
            $("#one-run").click();
        }
        this.TCPNormal(n);
    }

    OneLineTest.prototype.invalidNoPrefix = function (n) {
        var label_names = ["Src-side FW", "Dst-side FW", "Destination-NAT IP address"];
        var adjust_num = [8, 16];
        var that = this;
        var test_number;
        switch (n) {
            //Source FW
            case 0:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 1:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 2:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 3:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 4:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 5:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 6:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 7:
                this.InputForm(test.invalid_no_prefix_ips[n % 8], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            //Destination FW
            case 8:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 9:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 10:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 11:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 12:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 13:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 14:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            case 15:
                this.InputForm("", "", "", test.invalid_no_prefix_ips[n % 8], "", "", "", "", "");
                $("#one-run").click();
                break;
            //Nated Destination 空欄検査がないため1項目少ない
            case 16:
                console.log("ip: ", test.invalid_no_prefix_ips[n % 8 + 1])
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");//+1は空欄を避けるため
                $("#one-run").click();
                break;
            case 17:
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");
                $("#one-run").click();
                break;
            case 18:
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");
                $("#one-run").click();
                break;
            case 19:
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");
                $("#one-run").click();
                break;
            case 20:
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");
                $("#one-run").click();
                break;
            case 21:
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");
                $("#one-run").click();
                break;
            case 22:
                this.InputForm("", "", "", "", "", "", test.invalid_no_prefix_ips[n % 8 + 1], "");
                $("#one-run").click();
                break;
        }
        if (n < 8) {
            console.log("input: " + test.invalid_no_prefix_ips[n % 8])
            setTimeout(function () { that.AbnormalCheck(label_names[0] + " is invalid", label_names[0] + ":" + n); }, check_time);
        }
        else if (n < 16) {
            console.log("input: " + test.invalid_no_prefix_ips[n % 8])
            setTimeout(function () { that.AbnormalCheck(label_names[1] + " is invalid", label_names[1] + ":" + (n - adjust_num[0])); }, check_time);
        }
        else if (n < 23) {
            console.log("input: " + test.invalid_no_prefix_ips[n % 8])
            setTimeout(function () { that.AbnormalCheck(label_names[2] + " is invalid", label_names[2] + ":" + (n - adjust_num[1])); }, check_time);
        } else {
            console.info("Test End");
            count = -1;
        }
    }

    OneLineTest.prototype.invalidPrefix = function (n) {
        var label_names = ["Source IP address", "Destination IP address",];
        var that = this;
        switch (n) {
            case 0:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 1:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 2:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 3:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 4:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 5:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 6:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 7:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 8:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 9:
                this.InputForm(test.invalid_prefix_ips[n], "", "", "", "", "", "", "");
                $("#one-run").click();
                break;
            case 10:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 11:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 12:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 13:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 14:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 15:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 16:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 17:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 18:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
            case 19:
                this.InputForm("", "", "", test.invalid_prefix_ips[n % 10], "", "", "", "");
                $("#one-run").click();
                break;
        }
        if (n < 10) {
            setTimeout(function () { that.AbnormalCheck(label_names[0] + " is invalid", label_names[0] + ":" + n); }, check_time);
        } else if (n < 20) {
            setTimeout(function () { that.AbnormalCheck(label_names[1] + " is invalid", label_names[1] + ":" + n % 10); }, check_time);
        } else {
            console.info("Test End");
            count = -1;
        }
        // duplicate
        var duplicate_ips = [$("#settings-eth0-addr").val(), $("#settings-eth1-addr").val(), $("#settings-eth2-addr").val(), "192.0.2.1/24"];
        switch (n) {
            case 20:
                this.InputForm("", duplicate_ips[0], "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(ETH0)-Firewall network and Source IP address are duplicated", "duplicate ETH0"); }, check_time);
                break;
            case 21:
                this.InputForm("", duplicate_ips[1], "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(ETH1)-Firewall network and Source IP address are duplicated", "duplicate ETH1"); }, check_time);
                break;
            case 22:
                this.InputForm("", duplicate_ips[2], "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(ETH2)-Firewall network and Source IP address are duplicated", "duplicate ETH2"); }, check_time);
                break;
            case 23:
                this.InputForm("", duplicate_ips[3], "", "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(MGT0)-PC network and Source IP address are duplicated", "duplicate MGT0"); }, check_time);
                break;
            case 24:
                this.InputForm("", "", "", "", duplicate_ips[0], "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(ETH0)-Firewall network and Destination IP address are duplicated", "duplicate ETH0"); }, check_time);
                break;
            case 25:
                this.InputForm("", "", "", "", duplicate_ips[1], "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(ETH1)-Firewall network and Destination IP address are duplicated", "duplicate ETH1"); }, check_time);
                break;
            case 26:
                this.InputForm("", "", "", "", duplicate_ips[2], "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(ETH2)-Firewall network and Destination IP address are duplicated", "duplicate ETH2"); }, check_time);
                break;
            case 27:
                this.InputForm("", "", "", "", duplicate_ips[3], "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("NeedleWork(MGT0)-PC network and Destination IP address are duplicated", "duplicate MGT0"); }, check_time);
                break;
            default:
                if (n > 27) {
                    console.info("Test End");
                    count = -1;
                    break;
                }
        }
    }

    OneLineTest.prototype.invalidICMPPort = function (n) {
        var that = this;
        var invalid_ports = ["80"];
        switch (n) {
            case 0:
                this.InputForm("", "", invalid_ports[0], "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("In the case of ICMP, source port number can not be specified", "icmp source port"); }, check_time);
                break;
            case 1:
                this.InputForm("", "", "", "", "", invalid_ports[0], "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("In the case of ICMP, destination port number can not be specified", "icmp dest port"); }, check_time);
                break;
            case 2:
                this.InputForm("", "", "", "", "", "", "", invalid_ports[0]);
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("In the case of ICMP, destination NAT port number can not be specified", "icmp dest NAT port"); }, check_time);
                break;
            default:
                console.info("Test End");
                count = -1;
                break;
        }
    }

    OneLineTest.prototype.invalidPort = function (n) {
        var invalid_ports = ["0", "65536"];
        var label_names = ["Source port number", "Destination port number", "Destination-NAT port number"];
        var that = this;
        switch (n) {
            case 0:
                this.InputForm("", "", invalid_ports[0], "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck(label_names[0], "103"); }, check_time);
                break;
            case 1:
                this.InputForm("", "", invalid_ports[1], "", "", "", "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck(label_names[0], "104"); }, check_time);
                break;
            case 2:
                this.InputForm("", "", "", "", "", invalid_ports[0], "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck(label_names[1], "124"); }, check_time);
                break;
            case 3:
                this.InputForm("", "", "", "", "", invalid_ports[1], "", "");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck(label_names[1], "125"); }, check_time);
                break;
            case 4:
                this.InputForm("", "", "", "", "", "", "192.168.8.2", invalid_ports[0]);
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck(label_names[2], "133"); }, check_time);
                break;
            case 5:
                this.InputForm("", "", "", "", "", "", "192.168.8.2", invalid_ports[1]);
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck(label_names[2], "134"); }, check_time);
                break;
            case 6:
                this.InputForm("", "", "", "", "", "", "", "");//none dst port
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("In the case of TCP/UDP, the destination port number is required", "Destination Port Numberが未記入"); }, check_time);
                break;
            case 7:
                this.InputForm("", "", "", "", "", "", "", "80");
                $("#one-run").click();
                setTimeout(function () { that.AbnormalCheck("If NATed destination port number is specified, must specify NATed destination IP address", "NATed Destination Port Number(Optional)を記入"); }, check_time);
                break;
            default:
                console.info("Test End");
                count = -1;
                break;
        }
    }
}

//////OneLine Test
////Normal
//ICMP
$("#icmpnormal").click(function () {
    oneline_test.SelectProtocolName("ICMP");
    oneline_test.ICMPNormal(count);
    oneline_test.RemoveModal();
})
//TCP
$("#tcpnormal").click(function () {
    oneline_test.SelectProtocolName("TCP");
    oneline_test.TCPNormal(count);
    oneline_test.RemoveModal();
})
//UDP
$("#udpnormal").click(function () {
    oneline_test.SelectProtocolName("UDP");
    oneline_test.UDPNormal(count);
    oneline_test.RemoveModal();
})
////Abnormal
$("#invalidprotocol").click(function () {
    oneline_test.SelectProtocolName("");
    $("#one-run").click();
    setTimeout(function () {
        oneline_test.AbnormalCheck("Protocol name is invalid", "37");
        console.log("Test End");
    }, 300);
    oneline_test.RemoveModal();
})
//ICMP
$("#invalidicmpprefix").click(function () {
    oneline_test.SelectProtocolName("ICMP");
    oneline_test.invalidNoPrefix(count);
    oneline_test.RemoveModal();
})
$("#invalidicmpnoprefix").click(function () {
    oneline_test.SelectProtocolName("ICMP");
    oneline_test.invalidPrefix(count);
    oneline_test.RemoveModal();
})
$("#invalidicmpport").click(function () {
    oneline_test.SelectProtocolName("ICMP");
    oneline_test.invalidICMPPort(count);
    oneline_test.RemoveModal();
})
//TCP
$("#invalidtcpnoprefix").click(function () {
    oneline_test.SelectProtocolName("TCP");
    oneline_test.invalidNoPrefix(count);
    oneline_test.RemoveModal();
})
$("#invalidtcpprefix").click(function () {
    oneline_test.SelectProtocolName("TCP");
    oneline_test.invalidPrefix(count);
    oneline_test.RemoveModal();
})
$("#invalitcpdport").click(function () {
    oneline_test.SelectProtocolName("TCP");
    oneline_test.invalidPort(count);
    oneline_test.RemoveModal();
})
//UDP
$("#invalidudpnoprefix").click(function () {
    oneline_test.SelectProtocolName("UDP");
    oneline_test.invalidNoPrefix(count);
    oneline_test.RemoveModal();
})
$("#invalidudpprefix").click(function () {
    oneline_test.SelectProtocolName("UDP");
    oneline_test.invalidPrefix(count);
    oneline_test.RemoveModal();
})
$("#invalidudpport").click(function () {
    oneline_test.SelectProtocolName("UDP");
    oneline_test.invalidPort(count);
    oneline_test.RemoveModal();
})